Index: /trunk/src/org/expeditee/gui/Browser.java
===================================================================
--- /trunk/src/org/expeditee/gui/Browser.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Browser.java	(revision 1102)
@@ -19,36 +19,26 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Dimension;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.Image;
-import java.awt.MouseInfo;
-import java.awt.Point;
-import java.awt.RenderingHints;
-import java.awt.Toolkit;
-import java.awt.event.ComponentEvent;
-import java.awt.event.ComponentListener;
-import java.awt.event.WindowEvent;
-import java.awt.event.WindowListener;
-import java.awt.event.WindowStateListener;
 import java.io.File;
 import java.net.Authenticator;
-import java.net.URL;
 import java.util.ArrayList;
 import java.util.Collection;
-import java.util.LinkedList;
-
-import javax.swing.JFrame;
-import javax.swing.RepaintManager;
-import javax.swing.SwingUtilities;
-
-import org.expeditee.AbsoluteLayout;
+
 import org.expeditee.actions.Actions;
 import org.expeditee.actions.Simple;
 import org.expeditee.agents.mail.MailSession;
-import org.expeditee.importer.FrameDNDTransferHandler;
+import org.expeditee.core.BlockingRunnable;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.EcosystemManager.Ecosystem;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.InputManager;
+import org.expeditee.gio.InputManager.WindowEventListener;
+import org.expeditee.gio.InputManager.WindowEventType;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.io.ProxyAuth;
 import org.expeditee.items.Item;
+import org.expeditee.items.ItemUtils;
 import org.expeditee.items.Text;
 import org.expeditee.items.widgets.WidgetCacheManager;
@@ -68,16 +58,82 @@
  * processes any Events.
  * 
+ * TODO List:
+ * 
+ * Back to standard:
+ *  - JavaFX Text-hitting (requires JFX1.9)
+ *  - Overlays and Vectors review
+ *  - Pop-ups (unused in base Expeditee, only in Apollo)
+ *  - Apollo input (test)
+ *  - The rest of Apollo
+ *  - Make sure clipping/invalidation takes twin-frames into account
+ *  - Reinstate Simple input commands
+ *  - Test LinkedTrack.paintInFreeSpace()
+ *  - Test EmulatedTextItem.onMouseReleased(MouseEvent) (removed emulatedSource mouse button check)
+ *  - Constrained placement of items
+ *  
+ * Extra:
+ *  - Self-describing input
+ *  - Thread safety (most stuff on GIO event thread but Agents can start new threads)
+ *  - Touch input
+ *  - Better reflection??? (currently changes to the code break reflection as it relies on names)
+ *  - JavaFX lag (always rendering to images doesn't gel well with JavaFX)
+ *  - Swing widgets in JFX
+ *  - JavaFX Widgets (exception on drawing?)
+ *  - Reduce reliance on into-image rendering to improve JavaFX performance (utilise enforced-clip)
+ *  - Block Swing ecosystem setup until window is available, or...
+ *  - Reconfigure window-resized code so things are properly resized (PREFERRED).
+ *  - Swing alpha-compositing of colours (currently alpha is ignored e.g. drop-shadow in transition).
+ *  - Overly-thick extrusion lines (seems to depend on number of connected lines...)
+ *  - Make FreeItems control pickup etc.
+ *  - Remove MouseEventRouter
+ *  - Highlighting (should be controlled by the items themselves)
+ *  - Make Widgets into fully-fledged items (maybe???)
+ *  - Merge Widget and HeavyDutyWidget
+ *  - Redefine TextLayouts (relative/absolute layouts)
+ *  - Settings exceptions (Password widget in JFX) (currently fixed with hack)
+ *  - MessageBay (what did I mean by this specifically?)
+ *  - Order-dependency of start-up code
+ *  - MessageBay not refreshing at start-up
+ *  - Invalidation hierarchy (item => frame => display controller area => window)
+ *  - Add gesture data type checking
+ *  - Paintable interface
+ *  - EcosystemSpecific interface (utilise to enable/disable features based on ecosystem)
+ *  - Remove/modify Mutable class (in Apollo.util, change to InOutReference)
+ *  - Convert BlockingRunnable to interface
+ *  - Modify Metronome to utilise Timeouts
+ *  - Need AWT in FastAlphaEffect???
+ *  
+ * General:
+ *  - Tidy FrameGraphics
+ *  - Comment
+ *  - UserSettings.DEFAULT_PROFILE_NAME not actually a user setting
+ * 
+ * Done:
+ *  - Timers
+ *  - Timer input animations
+ *  - Finish DisplayController/FrameGraphics separation
+ *  - Anchor constraints (create class)
+ *  - Make MessageBay take lead from DisplayController
+ *  - Make message bay display again (to do with above)
+ *  - Tooltips (layout broken in Swing as window size not correct when tooltips laid out)
+ *  - Frame transitions
+ *  - Frame transitions in twin-frames mode drawing over each other
+ *  - JFX DnD manager
+ *  - Reinstate Simple
+ *  - Reinstate exclude source
+ *  - Reinstate commented code
+ *  - Twin-frames division 0 at startup
+ *  - Twin frames off-by-one frame size (draws a line of erroneous pixels)
+ *  - MessageBay delays showing messages on start-up
+ *  - JFX Antialiasing done on theScene??? Doesn't apply for our situation
+ *  - Incorporate Clip class into code
+ *  - Enforced clip
+ * 
+ * @author cts16
  * @author jdm18
- * 
  */
-public class Browser extends JFrame implements ComponentListener,
-		WindowListener, WindowStateListener, SaveStateChangedEventListener {
-
-	/**
-	 * Default version - just to stop eclipse from complaining about it.
-	 */
-	private static final long serialVersionUID = 1L;
-
-	// private static final JScrollPane scrollPane = new JScrollPane();
+public class Browser implements SaveStateChangedEventListener {
+	
+	public static final Ecosystem ECOSYSTEM_TYPE = Ecosystem.Swing;
 
 	public static Browser _theBrowser = null;
@@ -86,15 +142,7 @@
 
 	public static boolean _hasExited = false;
-	
-	protected MouseEventRouter _mouseEventRouter;
-
-	// A flag which is set once the application is exiting.
+
+	/** A flag which is set once the application is exiting. */
 	protected boolean _isExiting = false;
-
-	protected boolean _minimum_version6 = false;
-
-	public boolean isMinimumVersion6() {
-		return _minimum_version6;
-	}
 
 	protected static boolean _initComplete = false;
@@ -107,50 +155,44 @@
 	 * @param args
 	 */
-	public static void main(String[] args) {
-		
+	public static void main(String[] args)
+	{
+		// Parse the starting frame command-line argument
 		if(args.length > 0) {
 			_startFrame = args[0];
-			if(! Character.isDigit(_startFrame.charAt(_startFrame.length() - 1)))
-				_startFrame = _startFrame + "1";
-		}
-		else {
+			if(!Character.isDigit(_startFrame.charAt(_startFrame.length() - 1))) _startFrame = _startFrame + "1";
+		} else {
 		    _startFrame = "home1";
 		}
 
-		// Prepare all expeditee and swing data on the AWT event thread.
-		SwingUtilities.invokeLater(new Runnable() {
-			public void run() {
-				// MessageBay.supressMessages(true);
-
-				// MessageBay.supressMessages(false);
-
-				_theBrowser = new Browser();
-				
-				DisplayIO.refreshCursor();
-				_theBrowser.requestFocus();
-				FrameMouseActions.MouseX = MouseInfo.getPointerInfo()
-						.getLocation().x
-						- _theBrowser.getOrigin().x;
-				FrameMouseActions.MouseY = MouseInfo.getPointerInfo()
-						.getLocation().y
-						- _theBrowser.getOrigin().y;
-				_initComplete = true;
-				
-				Authenticator.setDefault(proxyAuth);
-			}
-		});
-
-	}
-
-	public Point getOrigin() {
-		return getContentPane().getLocationOnScreen();
-	}
-
-	/**
-	 * @return The mouse event router used for this browser. Never null after
-	 *         browser constructed.
-	 */
-	public MouseEventRouter getMouseEventRouter() {
-		return _mouseEventRouter;
+		// Window icon must be set before initialisation
+		GraphicsManager.setWindowIcon(DisplayController.ICON_IMAGE);
+		
+		// Setup the GIO ecosystem so it is ready when we need it
+		EcosystemManager.createEcosystem(ECOSYSTEM_TYPE);
+		
+		try {
+			EcosystemManager.getMiscManager().runOnGIOThread(new BlockingRunnable() {
+				@Override
+				public void execute() {
+					init();
+				}
+			});
+		} catch (Throwable e) {
+			e.printStackTrace(System.err);
+			System.exit(1);
+		}
+		
+		MessageBay.showDelayedMessages();
+	}
+	
+	public static void init()
+	{
+		_theBrowser = new Browser();
+
+		EcosystemManager.getGraphicsManager().requestFocus();
+		
+		Authenticator.setDefault(proxyAuth);
+		
+		_initComplete = true;
 	}
 
@@ -165,5 +207,5 @@
 	 * 
 	 */
-	public boolean isExisting() {
+	public boolean isExiting() {
 		return _isExiting;
 	}
@@ -173,147 +215,41 @@
 	}
 
-	public void setSizes(Dimension size) {
-		setSize(size);
-		setPreferredSize(size);
-		Dimension paneSize = getContentPane().getSize();
-		FrameGraphics.setMaxSize(paneSize);
-	}
-
-	protected Browser() {
+	protected Browser()
+	{
 		// center the frame on the screen
-		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
-		double xpos = screen.getWidth() / 2;
-		double ypos = screen.getHeight() / 2;
-		setLocation((int) (xpos - (UserSettings.InitialWidth.get() / 2)),
-				(int) (ypos - (UserSettings.InitialHeight.get() / 2)));
-
-		addWindowListener(this);
-		addWindowStateListener(this);
-
-		DisplayIO.addDisplayIOObserver(WidgetCacheManager.getInstance());
-		DisplayIO.addDisplayIOObserver(PopupManager.getInstance());
-
-		
-		// set up the image used for the icon
-	    try
-        {
-          URL iconURL = ClassLoader.getSystemResource("org/expeditee/assets/icons/expediteeicon128.png");
-          if (iconURL != null)
-          {
-            Image localImage = Toolkit.getDefaultToolkit().getImage(iconURL);
-            this.setIconImage(localImage);
-          }
-        }
-        catch (Exception e)
-        {
-          e.printStackTrace();
-        }
-	    
-	    setSizes(new Dimension(UserSettings.InitialWidth.get(), UserSettings.InitialHeight.get()));
-	    
-	    // set the layout to absolute layout for widgets
-	    // => this used to be done here, but now has been moved to later in the method
-	    //    as is works better when put in a JFXPanel
-	    //this.getContentPane().setLayout(new AbsoluteLayout());
-
-		_mouseEventRouter = new MouseEventRouter(getJMenuBar(),
-				getContentPane());
-
-		// enable the glasspane-for capturing all mouse events
-		this.setGlassPane(_mouseEventRouter);
-
-		this.getGlassPane().setVisible(true);
-		this.getContentPane().setBackground(Color.white);
-		this.getContentPane().setFocusTraversalKeysEnabled(false);
-
-		addComponentListener(this);
-		pack();
-		this.getContentPane().setLayout(new AbsoluteLayout()); // moved to here to work with JFXPanel
-
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		Dimension screen = g.getScreenSize();
+		double xpos = (screen.width - UserSettings.InitialWidth.get()) / 2.0;
+		double ypos = (screen.height - UserSettings.InitialHeight.get()) / 2.0;
+		g.setWindowLocation(new Point((int) xpos, (int) ypos));
+
+		DisplayController.Init();
+		
+		DisplayController.addDisplayObserver(WidgetCacheManager.getInstance());
+		if (ECOSYSTEM_TYPE == Ecosystem.Swing) {
+			DisplayController.addDisplayObserver(PopupManager.getInstance());
+		}
+
+		setInputManagerWindowRoutines();
+		
 		// Reset windows to user specified size
-		// Must be done after initialising the content pane above!
-		setSizes(new Dimension(UserSettings.InitialWidth.get(), UserSettings.InitialHeight.get()));
-	    
-		// UserSettings.ProfileName.set(FrameIO.ConvertToValidFramesetName(System.getProperty("user.name")));
-		String userName = UserSettings.ProfileName.get();
-		//UserSettings.UserName.set(UserSettings.ProfileName.get());
+		Dimension initialWindowSize = new Dimension(UserSettings.InitialWidth.get(), UserSettings.InitialHeight.get());
+		g.setWindowSize(initialWindowSize);
 		
 		// Load documentation and start pages
 		FrameUtils.extractResources(false);
+		
 		// Load fonts before loading any frames so the items on the frames will be able to access their fonts
 		Text.InitFonts();
-
-		Frame profile = loadProfile(userName);
-
-		// Need to display errors once things have been init otherwise
-		// exceptions occur if there are more than four messages neededing to be
-		// displayed.
-
-		Frame defaultProfile = loadProfile(UserSettings.DEFAULT_PROFILE_NAME);
-
-		Collection<String> warningMessages = new LinkedList<String>();
-		warningMessages.addAll(FrameUtils.ParseProfile(defaultProfile));
-		//Save the cursor if the defaultProfile had a custom cursor
-		Collection<Item> cursor = null;
-		if(FreeItems.hasCursor()){
-			cursor = new ArrayList<Item>();
-			cursor.addAll(FreeItems.getCursor());
-		}
-		warningMessages.addAll(FrameUtils.ParseProfile(profile));
-		if(cursor != null && !FreeItems.hasCursor()){
-			FreeItems.setCursor(cursor);
-		}
-
-		/*
-		 * See Java bug ID 4016934. They say that window closed events are
-		 * called once the JFrame is disposed.
-		 */
-		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
-		
-		// Expeditee handles its own repainting of AWT/Swing components
-		RepaintManager.setCurrentManager(ExpediteeRepaintManager.getInstance());
+		
+		Frame userProfile = loadProfiles();
 
 		// Listen for save status to display during and after runtime
 		EntitySaveManager.getInstance().addSaveStateChangedEventListener(this);
-
-		String full_version = System.getProperty("java.version");
-		String[] version_parts = full_version.split("\\.");
-		if (version_parts.length>=2) {
-			String version_str = version_parts[0] + "." + version_parts[1];
-			double version = Double.parseDouble(version_str);
-			
-			if (version >= 1.6) {
-				// Set the drag and drop handler
-				_minimum_version6 = true;
-				setTransferHandler(FrameDNDTransferHandler.getInstance());
-			} else {
-				System.err.println("Upgrade to a (minimum) of Java 1.6 to enable drag and drop support in Expeditee");
-			}
-		}
-		else {
-			System.err.println("Unable to parse Java version number " + full_version + " to determin if Drag and Drop supported");
-			
-		}
-		
-
+		
 		try {
-			warningMessages.addAll(Actions.Init());
+			MessageBay.warningMessages(Actions.Init());
 			
 			Settings.Init();
-
-			DisplayIO.Init(this);
-			// Set visible must be just after DisplayIO.Init for the message box
-			// to
-			// be the right size
-			setVisible(true);
-
-			setupGraphics();
-
-			// required to accept TAB key
-			setFocusTraversalKeysEnabled(false);
-
-			// Must be loaded after setupGraphics if images are on the frame
-			// Turn off XRay mode and load the first frame
-			FrameGraphics.setMode(FrameGraphics.MODE_NORMAL, false);
 			
 			// Go to the start frame if specified, otherwise go to the profile frame
@@ -321,51 +257,32 @@
 			if(_startFrame == null) {
 				_startFrame = UserSettings.StartFrame.get();
-				if(_startFrame != null && !Character.isDigit(_startFrame.charAt(_startFrame.length() - 1)))
+				if(_startFrame != null && !Character.isDigit(_startFrame.charAt(_startFrame.length() - 1))) {
 					_startFrame = _startFrame + "1";
-			}
+				}
+			}
+			
     		if((start = FrameIO.LoadFrame(_startFrame)) != null) {
     			// Make sure HomeFrame gets set
 		        UserSettings.HomeFrame.set(start.getName());
-		        //if (UserSettings.HomeFrame.get() == null) {
-			        //UserSettings.HomeFrame.set(profile.getName());
-
-			//}
-       			// Make sure the user can get back to the profile frame easily
-       			//DisplayIO.addToBack(profile);
+		        
        			// Go to the start frame
-       			DisplayIO.setCurrentFrame(start, true);
+       			DisplayController.setCurrentFrame(start, true);
     		} else {
     			// If an invalid start frame was specified, show a warning
-    			if(_startFrame != null) {
-    				warningMessages.add("Unknown frame: " + _startFrame);
-    			}
+    			if(_startFrame != null) MessageBay.warningMessage("Unknown frame: " + _startFrame);
+    			
     			// Go to the profile frame
-    			FrameUtils.loadFirstFrame(profile);
+    			FrameUtils.loadFirstFrame(userProfile);
     		}
-			DisplayIO.UpdateTitle();
-
-			/*
-			 * I think this can be moved back up to the top of the Go method
-			 * now... It used to crash the program trying to print error
-			 * messages up the top
-			 */
-			for (String message : warningMessages)
-				MessageBay.warningMessage(message);
-
-			this.getContentPane().addKeyListener(FrameKeyboardActions.getInstance());
-			this.addKeyListener(FrameKeyboardActions.getInstance());
-
-			_mouseEventRouter.addExpediteeMouseListener(FrameMouseActions.getInstance());
-			_mouseEventRouter.addExpediteeMouseMotionListener(FrameMouseActions.getInstance());
-			_mouseEventRouter.addExpediteeMouseWheelListener(FrameMouseActions.getInstance());
-
-			// Dont refresh for the profile frame otherwise error messages are shown twice
-			if (!DisplayIO.getCurrentFrame().equals(profile)) {
-				FrameKeyboardActions.Refresh();
+    		
+			DisplayController.updateTitle();
+
+			// Don't refresh for the profile frame otherwise error messages are shown twice
+			if (!DisplayController.getCurrentFrame().equals(userProfile)) {
+				StandardGestureActions.Refresh();
 			// If it's the profile frame just reparse it in order to display images/circles/widgets correctly
 			} else {
-				FrameUtils.Parse(profile);
-			}
-			// setVisible(true);
+				FrameUtils.Parse(userProfile);
+			}
 		} catch (Exception e) {
 			e.printStackTrace();
@@ -374,10 +291,221 @@
 	}
 
+	public void saveCompleted(SaveStateChangedEvent event)
+	{
+		MessageBay.displayMessage("Save finished!", Colour.BLUE);
+	}
+
+	public void saveStarted(SaveStateChangedEvent event)
+	{
+		String name = event.getEntity().getSaveName();
+		if (name == null) name = "data";
+		MessageBay.displayMessage("Saving " + name + "...", Colour.BLUE);
+	}
+
 	/**
-	 * @param userName
+	 * Closes the browser and ends the application. Performs saving operations -
+	 * halting until saves have completed. Feedback is given to the user while
+	 * the application is exiting. Must call on the swing thread.
+	 */
+	public void exit() {
+
+		// Set exiting flag
+		_isExiting = true;
+
+		MessageBay.displayMessage("System exiting...");
+
+		/**
+		 * TODO: Prompt the user etc.
+		 */
+
+		// TODO: Should we should a popup with a progress bar for user feedback?
+		// this would be nice and easy to do.
+		// Exit on a dedicated thread so that feedback can be obtained
+		new Exiter().start(); // this will exit the application
+	}
+
+	/**
+	 * The system must exit on a different thread other than the swing thread so
+	 * that the save threads can fire save-feedback to the swing thread and thus
+	 * provide user feedback on asynchronous save operations.
+	 * 
+	 * @author Brook Novak
+	 * 
+	 */
+	private class Exiter extends Thread {
+
+		@Override
+		public void run() {
+
+			// The final save point for saveable entities
+			EntitySaveManager.getInstance().saveAll();
+			try {
+				EntitySaveManager.getInstance().waitUntilAllSavingFinished();
+			} catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+			
+			// Stop any agents or simple programs
+			Simple.stop();
+			Actions.stopAgent();
+			// Wait for them to stop
+			try {
+				// Only stop if need to...
+				// Brook: What purpose does this serve?
+				MessageBay.displayMessage("Stopping Simple programs...");
+				while (Simple.isProgramRunning()) {
+					Thread.sleep(100);
+				}
+				
+				MessageBay.displayMessage("Stopping Agents...");
+				/* TODO: Only stop if need to... */
+				while (Actions.isAgentRunning()) {
+					Thread.sleep(100); // Brook: What purpose does this serve?
+				}
+			} catch (Exception e) {
+
+			}
+
+			MessageBay.displayMessage("Saving current frame...");
+			FrameIO.SaveFrame(DisplayController.getCurrentFrame());
+
+			MessageBay.displayMessage("Saving stats...");
+			StatsLogger.WriteStatsFile();
+
+			if (MailSession.getInstance() != null) {
+				if (MailSession.getInstance().finalise()) {
+					// TODO display this message before the finalising
+					// is done but only if the mail needs closing
+					MessageBay.displayMessage("Closed ExpMail...");
+				}
+			}
+
+			if (FrameShare.getInstance() != null) {
+				MessageBay.displayMessage("Stopping FrameServer...");
+				FrameShare.getInstance().finalise();
+			}
+
+			MessageBay.displayMessage("System exited");
+
+			// Finally remove the messages frameset
+			FrameIO.moveFrameset("messages", FrameIO.MESSAGES_PATH);
+
+			/*
+			 * Create a new messages folder so that it doesn't throw
+			 * Exceptions when two Expeditee's open at once and the
+			 * second tries to save its messages
+			 */
+			File file = new File(FrameIO.MESSAGES_PATH + "messages");
+			file.mkdirs();
+
+			Browser._hasExited = true;
+			
+			System.exit(0);
+		}
+	}
+
+	/**
+	 * Used to set up the the browser for use in testing.
+	 * 
 	 * @return
 	 */
-	protected Frame loadProfile(String userName) {
+	public static Browser initializeForTesting()
+	{
+		if (Browser._theBrowser == null) {
+			FrameShare.disableNetworking = true;
+			MailSession._autoConnect = false;
+
+			Browser.main(new String[]{});
+			try {
+				while (!isInitComplete()) {
+					Thread.sleep(10);
+				}
+			} catch (Exception e) {
+			}
+		}
+		return _theBrowser;
+	}
+	
+	private static void setInputManagerWindowRoutines()
+	{
+		InputManager manager = EcosystemManager.getInputManager();
+		
+	    // Refresh the layout when the window resizes
+		manager.addWindowEventListener(new WindowEventListener() {
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type != WindowEventType.WINDOW_RESIZED) return;
+				DisplayController.refreshWindowSize();
+				FrameIO.RefreshCacheImages();
+				for (Frame frame : DisplayController.getFrames()) {
+					if (frame != null) {
+						ItemUtils.Justify(frame);
+						frame.refreshSize();
+					}
+				}
+				DisplayController.requestRefresh(false);
+			}
+		});
+		
+		manager.addWindowEventListener(new WindowEventListener() {
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type != WindowEventType.MOUSE_EXITED_WINDOW) return;
+				StandardGestureActions.mouseExitedWindow();
+			}
+		});
+		
+		manager.addWindowEventListener(new WindowEventListener() {
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type != WindowEventType.MOUSE_ENTERED_WINDOW) return;
+				StandardGestureActions.mouseEnteredWindow();
+			}
+		});
+		
+		manager.addWindowEventListener(new WindowEventListener() {
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type != WindowEventType.WINDOW_CLOSED) return;
+				if (Browser._theBrowser != null) Browser._theBrowser.exit();
+			}
+		});
+	}
+
+	/**
+	 * @return The user's profile frame.
+	 */
+	private static Frame loadProfiles()
+	{
+		String defaultProfileName = UserSettings.DEFAULT_PROFILE_NAME;
+		String userName = UserSettings.ProfileName.get();
+
+		Frame defaultProfile = loadProfile(defaultProfileName);
+		Frame userProfile = loadProfile(userName);
+
+		MessageBay.warningMessages(FrameUtils.ParseProfile(defaultProfile));
+		
+		// Save the cursor if the defaultProfile had a custom cursor
+		Collection<Item> cursor = null;
+		if(FreeItems.hasCursor()) {
+			cursor = new ArrayList<Item>();
+			cursor.addAll(FreeItems.getCursor());
+		}
+		
+		MessageBay.warningMessages(FrameUtils.ParseProfile(userProfile));
+		
+		if (cursor != null && !FreeItems.hasCursor()) FreeItems.setCursor(cursor);
+		
+		return userProfile;
+	}
+
+	protected static Frame loadProfile(String userName)
+	{
 		Frame profile = FrameIO.LoadProfile(userName);
+		
 		if (profile == null) {
 			try {
@@ -392,247 +520,3 @@
 		return profile;
 	}
-
-	public Graphics2D g;
-
-	protected void setupGraphics() {
-		if (g != null)
-			g.dispose();
-		g = (Graphics2D) this.getContentPane().getGraphics();
-		assert (g != null);
-		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
-				RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
-		g.setFont(g.getFont().deriveFont(40f));
-		FrameGraphics.setDisplayGraphics(g);
-	}
-
-	// private int count = 0;
-	@Override
-	public void paint(Graphics g) {
-		// All this does is make sure the screen is repainted when the browser
-		// is moved so that some of the window is off the edge of the display
-		// then moved back into view
-		super.paint(g);
-		FrameGraphics.ForceRepaint();
-		// System.out.println("Paint " + count++);
-	}
-
-	/**
-	 * @inheritDoc
-	 */
-	public void componentResized(ComponentEvent e) {
-		setSizes(this.getSize());
-		setupGraphics();
-		FrameIO.RefreshCasheImages();
-		FrameGraphics.ForceRepaint();
-	}
-
-	/**
-	 * @inheritDoc
-	 */
-	public void componentMoved(ComponentEvent e) {
-		// FrameGraphics.setMaxSize(this.getSize());
-	}
-
-	/**
-	 * @inheritDoc
-	 */
-	public void componentShown(ComponentEvent e) {
-		DisplayIO.fullScreenTransitionPending=false;
-	}
-
-	/**
-	 * @inheritDoc
-	 */
-	public void componentHidden(ComponentEvent e) {
-	}
-
-	public void windowClosing(WindowEvent e) {
-	}
-
-	public void windowClosed(WindowEvent e) {
-		if (!DisplayIO.fullScreenTransitionPending) {
-			exit();
-		}
-	}
-
-	public void windowOpened(WindowEvent e) {
-	}
-
-	public void windowIconified(WindowEvent e) {
-	}
-
-	public void windowDeiconified(WindowEvent e) {
-	}
-
-	public void windowActivated(WindowEvent e) {
-	}
-
-	public void windowDeactivated(WindowEvent e) {
-	}
-
-	public void windowStateChanged(WindowEvent e) {
-	}
-
-	public int getDrawingAreaX() {
-		// return scrollPane.getLocationOnScreen().x;
-		return this.getLocationOnScreen().x;
-	}
-
-	public int getDrawingAreaY() {
-		// return scrollPane.getLocationOnScreen().y;
-		return this.getLocationOnScreen().y;
-	}
-
-	public void saveCompleted(SaveStateChangedEvent event) {
-		// if (isExisting()) {
-
-		// } else {
-		MessageBay.displayMessage("Save finished!", Color.BLUE);
-		// }
-	}
-
-	public void saveStarted(SaveStateChangedEvent event) {
-		// if (isExisting()) {
-
-		// } else {
-		String name = event.getEntity().getSaveName();
-		if (name == null)
-			name = "data";
-		MessageBay.displayMessage("Saving " + name + "...", Color.BLUE);
-		// }
-	}
-
-	/**
-	 * Closes the browser and ends the application. Performs saving operations -
-	 * halting until saves have completed. Feedback is given to the user while
-	 * the application is exiting. Must call on the swing thread.
-	 */
-	public void exit() {
-
-		// Set exiting flag
-		_isExiting = true;
-
-		MessageBay.displayMessage("System exiting...");
-
-		/**
-		 * TODO: Prompt the user etc.
-		 */
-
-		// TODO: Should we should a popup with a progress bar for user feedback?
-		// this would be nice and easy to do.
-		// Exit on a dedicated thread so that feedback can be obtained
-		new Exiter().start(); // this will exit the application
-	}
-
-	/**
-	 * The system must exit on a different thread other than the swing thread so
-	 * that the save threads can fire save-feedback to the swing thread and thus
-	 * provide user feedback on asynchronous save operations.
-	 * 
-	 * @author Brook Novak
-	 * 
-	 */
-	private class Exiter extends Thread {
-
-		@Override
-		public void run() {
-
-			// The final save point for saveable entities
-			EntitySaveManager.getInstance().saveAll();
-			try {
-				EntitySaveManager.getInstance().waitUntilAllSavingFinished();
-			} catch (InterruptedException e) {
-				e.printStackTrace();
-			}
-
-			// The final phase must save on the swing thread since dealing with
-			// the expeditee data model
-			SwingUtilities.invokeLater(new Runnable() {
-				public void run() {
-
-					// Stop any agents or simple programs
-					Simple.stop();
-					Actions.stopAgent();
-					// Wait for them to stop
-					try {
-						MessageBay
-								.displayMessage("Stopping Simple programs..."); // TODO:
-						/**
-						 * Only stop if need to...
-						 */
-						while (Simple.isProgramRunning()) {
-							Thread.sleep(100);
-							/* Brook: What purpose does this serve? */
-						}
-						MessageBay.displayMessage("Stopping Agents...");
-						/* TODO: Only stop if need to... */
-						while (Actions.isAgentRunning()) {
-							Thread.sleep(100); // Brook: What purpose does this
-							// serve?
-						}
-					} catch (Exception e) {
-
-					}
-
-					MessageBay.displayMessage("Saving current frame...");
-					FrameIO.SaveFrame(DisplayIO.getCurrentFrame());
-
-					MessageBay.displayMessage("Saving stats...");
-					StatsLogger.WriteStatsFile();
-
-					if (MailSession.getInstance() != null) {
-						if (MailSession.getInstance().finalise()) {
-							// TODO display this message before the finalising
-							// is done but only if the mail needs closing
-							MessageBay.displayMessage("Closed ExpMail...");
-						}
-					}
-
-					if (FrameShare.getInstance() != null) {
-						MessageBay.displayMessage("Stopping FrameServer...");
-						FrameShare.getInstance().finalise();
-					}
-
-					MessageBay.displayMessage("System exited");
-
-					// Finally remove the messages frameset
-					FrameIO.moveFrameset("messages", FrameIO.MESSAGES_PATH);
-
-					/*
-					 * Create a new messages folder so that it doesn't throw
-					 * Exceptions when two Expeditee's open at once and the
-					 * second tries to save its messages
-					 */
-					File file = new File(FrameIO.MESSAGES_PATH + "messages");
-					file.mkdirs();
-
-					Browser._hasExited = true;
-					
-					System.exit(0);
-				}
-			});
-		}
-	}
-
-	/**
-	 * Used to set up the the browser for use in testing.
-	 * 
-	 * @return
-	 */
-	public static Browser initializeForTesting() {
-		if (Browser._theBrowser == null) {
-			FrameShare.disableNetworking = true;
-			MailSession._autoConnect = false;
-
-			Browser.main(new String[]{});
-			try {
-				while (!isInitComplete()) {
-					Thread.sleep(10);
-				}
-			} catch (Exception e) {
-			}
-		}
-		return _theBrowser;
-	}
-
 }
Index: /trunk/src/org/expeditee/gui/ColorUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/ColorUtils.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/ColorUtils.java	(revision 1102)
@@ -19,5 +19,5 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
+import org.expeditee.core.Colour;
 
 public class ColorUtils {
@@ -36,5 +36,5 @@
 	 * @return the next color on the color wheel
 	 */
-	public static Color getNextColor(Color color, Color[] wheel, Color skip) {
+	public static Colour getNextColor(Colour color, Colour[] wheel, Colour skip) {
 		if (color == null) {
 			color = wheel[0];
